#ifndef BWIDGETS_DRAW_HPP
#define BWIDGETS_DRAW_HPP

#include <cstdint>
#include <functional>

struct SDL_PixelFormat;
struct SDL_Point;

namespace bwidgets
{
    class Color;
    class Renderer;
    class Texture;

    [[nodiscard]] auto aa(const Color&, int, float) noexcept -> Color;
    [[nodiscard]] auto filled_circle(const Color&, int resolution, Renderer*,
                                     int aa_pixels = 3) -> Texture*;
    void               set_pixels_color(
                    Texture*,
                    const std::function<uint32_t(const SDL_Point&, const SDL_PixelFormat*)>&);
}

#endif
