#ifndef BWIDGETS_WIDGET_HPP
#define BWIDGETS_WIDGET_HPP

#include <basic_widgets/core/renderer.hpp>
#include <basic_widgets/core/type/size.hpp>

union SDL_Event;

struct SDL_Renderer;

namespace bwidgets
{
    class Widget
    {
    protected:
        Renderer* _renderer {nullptr};
        SDL_Rect  _viewport {0, 0, 0, 0};
        SDL_Rect  _widget_area {0, 0, 0, 0};

        virtual void _handle_geometry_change(const SDL_Rect&) noexcept = 0;
        virtual void _handle_renderer_change(Renderer*) {}
        virtual void _handle_rendering() = 0;

    public:
        Widget* parent;

        Widget(Widget* p = nullptr) : parent(p) {}

        virtual ~Widget() noexcept = default;

        virtual auto               handle_event(const SDL_Event&) -> Widget*;
        [[nodiscard]] virtual auto size() const noexcept -> Size = 0;
        virtual auto               render() -> Widget* final;
        virtual auto               renderer(Renderer*) -> Widget* final;
        virtual auto               viewport(const SDL_Rect&) noexcept -> Widget* final;
        [[nodiscard]] virtual auto viewport() const noexcept -> const SDL_Rect& final;
    };
}

#endif
